﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Text
Imports System.Web.UI.WebControls
Imports Microsoft.SharePoint
Imports Microsoft.SharePoint.WebControls


Namespace OfficeSpaceFieldTypes

  Public Class FieldHelloWorld
	  Inherits SPFieldText
	Public Sub New(ByVal fields As SPFieldCollection, ByVal fieldName As String)
		MyBase.New(fields, fieldName)
	End Sub

	Public Sub New(ByVal fields As SPFieldCollection, ByVal typeName As String, ByVal displayName As String)
		MyBase.New(fields, typeName, displayName)
	End Sub

	Public Overrides ReadOnly Property FieldRenderingControl() As BaseFieldControl
	  Get
		Dim ctr As BaseFieldControl = New HelloWorldFieldControl()
		ctr.FieldName = Me.InternalName
		Return ctr
	  End Get
	End Property
	Public Overrides ReadOnly Property DefaultValue() As String
	  Get
		Return "Hello World (default value)"
	  End Get
	End Property
  End Class

  Public Class HelloWorldFieldControl
	  Inherits BaseFieldControl
	Protected txtUserInput As TextBox
	Protected Overrides ReadOnly Property DefaultTemplateName() As String
	  Get
		Return "HelloWorldRendingTemplate"
	  End Get
	End Property
	Protected Overrides Sub CreateChildControls()
	  MyBase.CreateChildControls()
	  txtUserInput = CType(Me.TemplateContainer.FindControl("txtUserInput"), TextBox)
	End Sub

	Public Overrides Property Value() As Object
	  Get
		Me.EnsureChildControls()
		Return txtUserInput.Text
	  End Get
	  Set(ByVal value As Object)
		Me.EnsureChildControls()
		txtUserInput.Text = CStr(Me.ItemFieldValue)
	  End Set
	End Property
  End Class
End Namespace
